SystemOrganization addCategory: #DolphinImport!

UUID variableByteSubclass: #GUID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

!GUID class methodsFor: 'actions' stamp: 'sebastiansastre 2/28/2012 16:18'!
fromString: aString

	^  super fromString: (aString copyWithoutAll: '{}')! !

DynamicVariable subclass: #CurrentDolphinPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

Object subclass: #DolphinChunkReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

Object subclass: #DolphinImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

!DolphinImport class methodsFor: 'actions' stamp: 'sebastiansastre 2/28/2012 17:02'!
installPac: aFilename

	^ (self pac: aFilename) install! !

!DolphinImport class methodsFor: 'actions' stamp: 'sebastiansastre 2/28/2012 17:02'!
pac: aFilename

	^  DolphinPackage on: aFilename! !

Object subclass: #DolphinPackage
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

!DolphinPackage class methodsFor: 'actions' stamp: 'sebastiansastre 2/27/2012 22:03'!
on: aStringAbstolutePath

	^ self new 
		path: (FSAbsolutePath from: aStringAbstolutePath delimiter: $/);
		yourself! !

!DolphinPackage methodsFor: 'actions' stamp: 'sebastiansastre 2/27/2012 23:40'!
install

	CurrentDolphinPackage 
		value: self packageName
		during: [self pharoishSource readStream fileIn]! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:43'!
packageName

	^ (self raw readStream 
		upToAll: 'Package name: ';
		nextLine) allButFirst allButLast:2! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 21:37'!
path

	^ path! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 21:37'!
path: aPath

	path := aPath! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:46'!
pharoishSource

	^ self pharoishSourceFrom: self raw	
	
	! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:50'!
pharoishSourceFrom: someSolphinCode
	
	^ someSolphinCode
		copyWithRegex: '(Package)' matchesReplacedWith: 'DolphinPackageForImport'! !

!DolphinPackage methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:04'!
raw

	^ (path asReference readStreamDo:[:s|
		s contents]) asString
	
	! !

Object subclass: #DolphinPackageForImport
	instanceVariableNames: 'name comment classNames methodNames binaryGlobalNames globalAliases prerequisites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DolphinImport'!

!DolphinPackageForImport class methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:45'!
name: aString

	^ self new
		name: aString;
		yourself! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:20'!
basicComment: aString

	comment := aString! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:20'!
basicDolphinPackageForImportVersion: aString! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:25'!
binaryGlobalNames: aSet

	binaryGlobalNames := aSet! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:22'!
classNames

	^ classNames ifNil:[self initializeClassNames]! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:25'!
globalAliases: aSet

	globalAliases := aSet! !

!DolphinPackageForImport methodsFor: 'initialization' stamp: 'sebastiansastre 2/27/2012 23:21'!
initializeClassNames

	^ classNames := OrderedCollection new! !

!DolphinPackageForImport methodsFor: 'initialization' stamp: 'sebastiansastre 2/27/2012 23:24'!
initializeMethodNames

	^ methodNames := OrderedCollection new! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:23'!
methodNames

	^ methodNames ifNil:[self initializeMethodNames]! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:45'!
name

	^ name ! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 22:45'!
name: aString

	name := aString! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:19'!
paxVersion: anInteger! !

!DolphinPackageForImport methodsFor: 'accessing' stamp: 'sebastiansastre 2/27/2012 23:27'!
setPrerequisites: aSet

	prerequisites := aSet! !
